function [Yhat,Yt] = ConvertToLevels(Yhat,Yt,data,tfvars,yloc,rerloc,SkipObs,Strategy);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% A function designed to convert the actual and fitted values
% from the Kalman filter to levels for each variable.
% Written and last modified by Jesper Lind 2004-03-05.
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if Strategy == 1|Strategy == 2;
   for t=1:length(Yhat);
      Yhat(t,tfvars) = Yhat(t,tfvars)+data(SkipObs+t,tfvars+1);%note: first column in data is date variable.
      Yt(t,tfvars)   = Yt(t,tfvars)+data(SkipObs+t,tfvars+1);%note: first column in data is date variable.
      if max(abs(Yt(t,:)'-data(SkipObs+t+1,2:end)')) > 1e-5;
         error('ConvertToLevels: Original and data from Kalman filter do not add up...');
      end;
   end;
elseif Strategy == 3;
   for t=1:length(Yhat);%generating actual and projected GDP level
      Yhat(t,yloc-1) = Yhat(t,yloc-1)+data(SkipObs+t,yloc);%note: first column in data is date variable.
      Yt(t,yloc-1)   = Yt(t,yloc-1)  +data(SkipObs+t,yloc);%note: first column in data is date variable.
      if max(abs(Yt(t,yloc-1)'-data(SkipObs+t+1,yloc)')) > 1e-5;
         error('ConvertToLevels: Original and data from Kalman filter do not add up...');
      end;
      Yhat(t,rerloc-1) = Yhat(t,rerloc-1)+data(SkipObs+t,rerloc);%note: first column in data is date variable.
      Yt(t,rerloc-1)   = Yt(t,rerloc-1)  +data(SkipObs+t,rerloc);%note: first column in data is date variable.
      if max(abs(Yt(t,rerloc-1)'-data(SkipObs+t+1,rerloc)')) > 1e-5;
         error('ConvertToLevels: Original and data from Kalman filter do not add up...');
      end;
   end;
   Yhat(:,tfvars) = Yhat(:,tfvars)+Yhat(:,yloc-1)*ones(1,length(tfvars));%adding projected GDP level to projected x-y.
   Yt(:,tfvars)   = Yt(:,tfvars)+data(SkipObs+2:end,yloc)*ones(1,length(tfvars));% series for w,c,i,g,x,m and y*
   if max(max(abs(Yt-data(SkipObs+2:end,2:end)))) > 1e-5;
      error('ConvertToLevels: Original and data from Kalman filter do not add up...');
   end;
end;
