
% Construct labels for the components of the decomposition
DecompLabels=cell(NDecomp,1);
DecompLabels{1}='No Shocks';
for DecompCounter=2:NDecomp
    DecompLabels{DecompCounter}=['Shocks: ',int2str(HistDecompShocks{DecompCounter})];
end

% Computing the median of the decomposed fit
MedianHistDecompPreds=zeros(NDecompPeriods,p,NDecomp);
for j=1:NDecomp
    for h=1:NDecompPeriods
        MedianHistDecompPreds(h,:,j)=median(HistDecompPreds(:,:,h,j),1);
    end
end

FigHandle=figure;
set(FigHandle,'name','Historical Decomposition')
NDecompVars=length(DeCompVars);
SubPlotCount=0;
for DecompCounter=DeCompScenarios(2:end) % First scenario is without shocks.
    for j=DeCompVars
        SubPlotCount=SubPlotCount+1;
        subplot(length(DeCompScenarios(2:end)),NDecompVars,SubPlotCount)
        hold on  
        LineHandle=plot(EstDates(K+1:end),DecompData(:,j),'k');
        set(LineHandle,'LineWidth',2.5)
        LineHandle=plot(EstDates(K+1:end),MedianHistDecompPreds(:,j,1),'r-');
        set(LineHandle,'LineWidth',1.5)
        LineHandle=plot(EstDates(K+1:end),MedianHistDecompPreds(:,j,DecompCounter),'b--');
        set(LineHandle,'LineWidth',1.5)
        if rem(SubPlotCount,NDecompVars)==1
            YLabelHandle=ylabel(DecompLabels{DecompCounter});
            set(YLabelHandle,'fontsize',8)
            if j==DeCompVars(1) && DecompCounter==DeCompScenarios(2)
                LegendHandle=legend('Data','No Shocks','With Shocks');
            end
        end
        TitleHandle=title(varlabels{j});
        
        set(gca,'xlim',[EstDates(K+1) EstDates(end)])
        set(gca,'fontsize',8)
    end
end
%LegendHandle=legend('Data','No Shocks','With Shocks')
%set(LegendHandle,'orientation','horizontal','location','southoutside')