function [Y,X,D]=datmanip_meanadj(ENDO,EXO,var_order)

% Computes datamatrices for the multivariate regression Y=X*PI+D*Theta,
% where PI'=[PI_{1},...,PI_{k}], Theta'=[Phi,PI_{1}*Phi,...PI_{k}*Phi] and
% t-th row of D is [d_{t},-d_{t-1},...,-d_{t-k}].

T=size(ENDO,1);
X=[];
for i=1:var_order
    X=[X lag(ENDO,i)];
end
X=X(var_order+1:T,:);
Y=ENDO(var_order+1:T,:);

D=EXO;
for i=1:var_order
    D=[D -lag(EXO,i)];
end
D=D(var_order+1:T,:);